/* I'm not proud ... */

#include <conio.h>
#include <dos.h>
#include <dpmi.h>
#include <go32.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

typedef struct
{ int n, rot;
  char color;
} piece;

char pieces[7][4][16]; /* initialized below */
char playfield[12][24];

#define flip(vs) dosmemput(vs, 80*25*2, 0xb8000)

char vscreen[80*25*2];

void set80x25()
{ __dpmi_regs r;

  r.x.ax=3;
  __dpmi_int(0x10, &r);
}

void initvscreen()
{ int i;
  for(i=0; i<80*25; i++)
    vscreen[i]=i%2?7:32;
}

void putbrick(int x, int y, int c)
{ vscreen[(y+1)*160+x*4]=vscreen[(y+1)*160+x*4+2]=219;
  vscreen[(y+1)*160+x*4+1]=vscreen[(y+1)*160+x*4+3]=c;
}

void putstring(int x, int y, char *s)
{ for(; *s; x++, s++) vscreen[y*160+x*2]=*s;
}

void drawfield(int x, int y, piece p, int level, int lines, int score)
{ int i, j;
  static char s[80];

  for(i=0; i<12; i++)
    for(j=0; j<24; j++)
      putbrick(i, j, playfield[i][j]);

  for(i=0; i<4; i++)
    for(j=0; j<4; j++)
      if(pieces[p.n][p.rot][i+j*4])
        putbrick(x+i, j+y, p.color);

  sprintf(s, "Score: %d  Lines: %d  Level: %d", score, lines, level);
  putstring(0, 0, s);

  flip(vscreen);
}

void initfield()
{ int i;

  for(i=0; i<12; i++) playfield[i][23]=1;
  for(i=0; i<24; i++) playfield[0][i]=playfield[11][i]=1;
}

void addpiece(int x, int y, piece p)
{ int i, j;

  for(i=0; i<4; i++)
    for(j=0; j<4; j++)
      if(pieces[p.n][p.rot][j*4+i])
        playfield[x+i][y+j]=p.color;
}

void removepiece(int x, int y, piece p)
{ int i, j;

  for(i=0; i<4; i++)
    for(j=0; j<4; j++)
      if(pieces[p.n][p.rot][j*4+i])
        playfield[x+i][y+j]=0;
}

int isclear(int x, int y, piece p)
{ int i, j;

  for(i=0; i<4; i++)
    for(j=0; j<4; j++)
      if(pieces[p.n][p.rot][j*4+i] && playfield[x+i][y+j]) return 0;

  return 1;
}

piece rotate(piece p)
{ if(++p.rot>3) p.rot=0;

  return p;
}

int rowcomplete(int r)
{ int i;
  for(i=0; i<12; i++) if(!playfield[i][r]) return 0;
  return 1;
}

void removerow(int r)
{ int i, j;

  for(i=r; i>0; i--)
    for(j=1; j<11; j++)
      playfield[j][i]=playfield[j][i-1];
}

int results(int x, piece p)
{ int i, n, y;

  if(!isclear(x, 0, p)) return 0;
  for(y=0; isclear(x, y+1, p); y++);

  addpiece(x, y, p);

  for(n=i=0; i<23; i++)
    if(rowcomplete(i)) n++;

  removepiece(x, y, p);

  return n;
}

int max(int a, int b)
{ return a>b?a:b;
}

#define PASTN 7

piece selectpiece()
{ piece p;
  static int colors[7]={ 9, 10, 11, 14, 13, 6, 12 };
  static int past[PASTN];
  int goodness[7]={ 0, 0, 0, 0, 0, 0, 0 };
  int badness[5]={ 1000000, 10000, 1000, 100, 10 };
  int i, j, n=0;

  for(p.n=0; p.n<7; p.n++)
    for(p.rot=0; p.rot<=4; p.rot++)
      for(i=0; i<12; i++)
        goodness[p.n]=max(results(i, p), goodness[p.n]);

  for(i=0; i<7; i++)
  { goodness[i]=badness[goodness[i]];
    for(j=0; j<PASTN; j++)
      if(i==past[j]) goodness[i]/=2;
    n+=goodness[i];
  }

  n=rand()%n;

  for(p.n=0; p.n<7 && n>=0; p.n++) n-=goodness[p.n];
  p.n--;

  p.color=colors[p.n];
  p.rot=0;

  for(i=0; i<PASTN-1; i++)
    past[i]=past[i+1];
  past[PASTN-1]=p.n;

  return p;
}

int delayc=40, lines=0, level=0, score=0;

void gameloop()
{ char c=0;
  piece p;
  int i, x, y, n;
  int tdelay;
  static int leveld[15]=
    { 25, 20, 18, 15, 12, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };

  srand(time(0));
  initfield();
  p=selectpiece();
  x=5, y=0;
  tdelay=delayc;
  do
  { drawfield(x, y, p, level, lines, score);
    while(kbhit())
    { c=getch();
      switch(c)
      { case '4': if(isclear(x-1, y, p)) x--; break;
        case '6': if(isclear(x+1, y, p)) x++; break;
        case '2': tdelay=1; break;
        case '5': if(isclear(x, y, rotate(p))) p=rotate(p); break;
      }
    }
    if(!--tdelay)
    { if(isclear(x, y+1, p)) y++;
      else
      { addpiece(x, y, p);
        for(n=i=0; i<23; i++)
          if(rowcomplete(i))
          { removerow(i);
            lines++;
            level=lines/10;
            if(level<15) delayc=leveld[level];
            n++;
          }
        score+=n*n*(level+1);
        p=selectpiece();
        x=5, y=0, tdelay=delayc;
        if(!isclear(x, y, p)) return;
      }
      tdelay=delayc;
    }
    usleep(UCLOCKS_PER_SEC/100);
  }while(c!=27);
}

int main()
{ initvscreen();
  putstring(26, 2, "HardRis v0.21 by Jim Crawford (pfister_@hotmail.com)");
  putstring(26, 4, "5:rotate");
  putstring(26, 5, "4:left 6:right");
  putstring(26, 6, "2:drop");
  putstring(26, 7, "esc: quit");

  gameloop();
  set80x25();
  printf("Score: %d  Lines: %d  Level: %d", score, lines, level);

  return 0;
}

/* I'm especially not proud of this.  It would've been significantly harder
   to algorithmically make the pieces rotate in a pleasing way. */   

char pieces[7][4][16]=
{ { { 1, 1, 0, 0,
      1, 1, 0, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    },
    { 1, 1, 0, 0,
      1, 1, 0, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    },
    { 1, 1, 0, 0,
      1, 1, 0, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    },
    { 1, 1, 0, 0,
      1, 1, 0, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    }
  },
  { { 0, 1, 0, 0,
      0, 1, 1, 0,
      0, 0, 1, 0,
      0, 0, 0, 0
    },
    { 0, 1, 1, 0,
      1, 1, 0, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    },
    { 0, 1, 0, 0,
      0, 1, 1, 0,
      0, 0, 1, 0,
      0, 0, 0, 0
    },
    { 0, 1, 1, 0,
      1, 1, 0, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    }
  },
  { { 0, 0, 1, 0,
      0, 1, 1, 0,
      0, 1, 0, 0,
      0, 0, 0, 0
    },
    { 1, 1, 0, 0,
      0, 1, 1, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    },
    { 0, 0, 1, 0,
      0, 1, 1, 0,
      0, 1, 0, 0,
      0, 0, 0, 0
    },
    { 1, 1, 0, 0,
      0, 1, 1, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    }
  },
  { { 0, 1, 0, 0,
      0, 1, 1, 0,
      0, 1, 0, 0,
      0, 0, 0, 0
    },
    { 0, 1, 0, 0,
      1, 1, 1, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    },
    { 0, 1, 0, 0,
      1, 1, 0, 0,
      0, 1, 0, 0,
      0, 0, 0, 0
    },
    { 0, 0, 0, 0,
      1, 1, 1, 0,
      0, 1, 0, 0,
      0, 0, 0, 0
    }
  },
  { { 0, 1, 0, 0,
      0, 1, 0, 0,
      0, 1, 1, 0,
      0, 0, 0, 0
    },
    { 0, 0, 1, 0,
      1, 1, 1, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    },
    { 1, 1, 0, 0,
      0, 1, 0, 0,
      0, 1, 0, 0,
      0, 0, 0, 0
    },
    { 0, 0, 0, 0,
      1, 1, 1, 0,
      1, 0, 0, 0,
      0, 0, 0, 0
    }
  },
  { { 0, 1, 0, 0,
      0, 1, 0, 0,
      1, 1, 0, 0,
      0, 0, 0, 0
    },
    { 0, 0, 0, 0,
      1, 1, 1, 0,
      0, 0, 1, 0,
      0, 0, 0, 0
    },
    { 0, 1, 1, 0,
      0, 1, 0, 0,
      0, 1, 0, 0,
      0, 0, 0, 0
    },
    { 1, 0, 0, 0,
      1, 1, 1, 0,
      0, 0, 0, 0,
      0, 0, 0, 0
    }
  },
  { { 0, 1, 0, 0,
      0, 1, 0, 0,
      0, 1, 0, 0,
      0, 1, 0, 0
    },
    { 0, 0, 0, 0,
      1, 1, 1, 1,
      0, 0, 0, 0,
      0, 0, 0, 0
    },
    { 0, 1, 0, 0,
      0, 1, 0, 0,
      0, 1, 0, 0,
      0, 1, 0, 0
    },
    { 0, 0, 0, 0,
      1, 1, 1, 1,
      0, 0, 0, 0,
      0, 0, 0, 0
    }
  }
};
